package io.fabric8.openshift.api.model.operatorhub.v1;

import io.fabric8.kubernetes.api.model.Condition;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

 /**
  * Generated
  */
public class OperatorConditionSpecFluentImpl<A extends io.fabric8.openshift.api.model.operatorhub.v1.OperatorConditionSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.openshift.api.model.operatorhub.v1.OperatorConditionSpecFluent<A>{
  public OperatorConditionSpecFluentImpl() {
  }
  public OperatorConditionSpecFluentImpl(io.fabric8.openshift.api.model.operatorhub.v1.OperatorConditionSpec instance) {
    this.withDeployments(instance.getDeployments()); 
    this.withOverrides(instance.getOverrides()); 
    this.withServiceAccounts(instance.getServiceAccounts()); 
  }
  private java.util.List<java.lang.String> deployments = new java.util.ArrayList<java.lang.String>();
  private java.util.List<io.fabric8.kubernetes.api.model.Condition> overrides = new java.util.ArrayList<io.fabric8.kubernetes.api.model.Condition>();
  private java.util.List<java.lang.String> serviceAccounts = new java.util.ArrayList<java.lang.String>();
  public A addToDeployments(java.lang.Integer index,java.lang.String item) {
    if (this.deployments == null) {this.deployments = new java.util.ArrayList<java.lang.String>();}
    this.deployments.add(index, item);
    return (A)this;
  }
  public A setToDeployments(java.lang.Integer index,java.lang.String item) {
    if (this.deployments == null) {this.deployments = new java.util.ArrayList<java.lang.String>();}
    this.deployments.set(index, item); return (A)this;
  }
  public A addToDeployments(java.lang.String... items) {
    if (this.deployments == null) {this.deployments = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.deployments.add(item);} return (A)this;
  }
  public A addAllToDeployments(java.util.Collection<java.lang.String> items) {
    if (this.deployments == null) {this.deployments = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.deployments.add(item);} return (A)this;
  }
  public A removeFromDeployments(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.deployments!= null){ this.deployments.remove(item);}} return (A)this;
  }
  public A removeAllFromDeployments(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.deployments!= null){ this.deployments.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getDeployments() {
    return this.deployments;
  }
  public java.lang.String getDeployment(java.lang.Integer index) {
    return this.deployments.get(index);
  }
  public java.lang.String getFirstDeployment() {
    return this.deployments.get(0);
  }
  public java.lang.String getLastDeployment() {
    return this.deployments.get(deployments.size() - 1);
  }
  public java.lang.String getMatchingDeployment(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: deployments) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingDeployment(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: deployments) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withDeployments(java.util.List<java.lang.String> deployments) {
    if (deployments != null) {this.deployments = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : deployments){this.addToDeployments(item);}} else { this.deployments = null;} return (A) this;
  }
  public A withDeployments(java.lang.String... deployments) {
    if (this.deployments != null) {this.deployments.clear();}
    if (deployments != null) {for (java.lang.String item :deployments){ this.addToDeployments(item);}} return (A) this;
  }
  public java.lang.Boolean hasDeployments() {
    return deployments != null && !deployments.isEmpty();
  }
  public A addNewDeployment(java.lang.String arg0) {
    return (A)addToDeployments(new String(arg0));
  }
  public A addToOverrides(java.lang.Integer index,io.fabric8.kubernetes.api.model.Condition item) {
    if (this.overrides == null) {this.overrides = new java.util.ArrayList<io.fabric8.kubernetes.api.model.Condition>();}
    this.overrides.add(index, item);
    return (A)this;
  }
  public A setToOverrides(java.lang.Integer index,io.fabric8.kubernetes.api.model.Condition item) {
    if (this.overrides == null) {this.overrides = new java.util.ArrayList<io.fabric8.kubernetes.api.model.Condition>();}
    this.overrides.set(index, item); return (A)this;
  }
  public A addToOverrides(io.fabric8.kubernetes.api.model.Condition... items) {
    if (this.overrides == null) {this.overrides = new java.util.ArrayList<io.fabric8.kubernetes.api.model.Condition>();}
    for (io.fabric8.kubernetes.api.model.Condition item : items) {this.overrides.add(item);} return (A)this;
  }
  public A addAllToOverrides(java.util.Collection<io.fabric8.kubernetes.api.model.Condition> items) {
    if (this.overrides == null) {this.overrides = new java.util.ArrayList<io.fabric8.kubernetes.api.model.Condition>();}
    for (io.fabric8.kubernetes.api.model.Condition item : items) {this.overrides.add(item);} return (A)this;
  }
  public A removeFromOverrides(io.fabric8.kubernetes.api.model.Condition... items) {
    for (io.fabric8.kubernetes.api.model.Condition item : items) {if (this.overrides!= null){ this.overrides.remove(item);}} return (A)this;
  }
  public A removeAllFromOverrides(java.util.Collection<io.fabric8.kubernetes.api.model.Condition> items) {
    for (io.fabric8.kubernetes.api.model.Condition item : items) {if (this.overrides!= null){ this.overrides.remove(item);}} return (A)this;
  }
  public java.util.List<io.fabric8.kubernetes.api.model.Condition> getOverrides() {
    return this.overrides;
  }
  public io.fabric8.kubernetes.api.model.Condition getOverride(java.lang.Integer index) {
    return this.overrides.get(index);
  }
  public io.fabric8.kubernetes.api.model.Condition getFirstOverride() {
    return this.overrides.get(0);
  }
  public io.fabric8.kubernetes.api.model.Condition getLastOverride() {
    return this.overrides.get(overrides.size() - 1);
  }
  public io.fabric8.kubernetes.api.model.Condition getMatchingOverride(java.util.function.Predicate<io.fabric8.kubernetes.api.model.Condition> predicate) {
    for (io.fabric8.kubernetes.api.model.Condition item: overrides) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingOverride(java.util.function.Predicate<io.fabric8.kubernetes.api.model.Condition> predicate) {
    for (io.fabric8.kubernetes.api.model.Condition item: overrides) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withOverrides(java.util.List<io.fabric8.kubernetes.api.model.Condition> overrides) {
    if (overrides != null) {this.overrides = new java.util.ArrayList<io.fabric8.kubernetes.api.model.Condition>(); for (io.fabric8.kubernetes.api.model.Condition item : overrides){this.addToOverrides(item);}} else { this.overrides = null;} return (A) this;
  }
  public A withOverrides(io.fabric8.kubernetes.api.model.Condition... overrides) {
    if (this.overrides != null) {this.overrides.clear();}
    if (overrides != null) {for (io.fabric8.kubernetes.api.model.Condition item :overrides){ this.addToOverrides(item);}} return (A) this;
  }
  public java.lang.Boolean hasOverrides() {
    return overrides != null && !overrides.isEmpty();
  }
  public A addToServiceAccounts(java.lang.Integer index,java.lang.String item) {
    if (this.serviceAccounts == null) {this.serviceAccounts = new java.util.ArrayList<java.lang.String>();}
    this.serviceAccounts.add(index, item);
    return (A)this;
  }
  public A setToServiceAccounts(java.lang.Integer index,java.lang.String item) {
    if (this.serviceAccounts == null) {this.serviceAccounts = new java.util.ArrayList<java.lang.String>();}
    this.serviceAccounts.set(index, item); return (A)this;
  }
  public A addToServiceAccounts(java.lang.String... items) {
    if (this.serviceAccounts == null) {this.serviceAccounts = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.serviceAccounts.add(item);} return (A)this;
  }
  public A addAllToServiceAccounts(java.util.Collection<java.lang.String> items) {
    if (this.serviceAccounts == null) {this.serviceAccounts = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.serviceAccounts.add(item);} return (A)this;
  }
  public A removeFromServiceAccounts(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.serviceAccounts!= null){ this.serviceAccounts.remove(item);}} return (A)this;
  }
  public A removeAllFromServiceAccounts(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.serviceAccounts!= null){ this.serviceAccounts.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getServiceAccounts() {
    return this.serviceAccounts;
  }
  public java.lang.String getServiceAccount(java.lang.Integer index) {
    return this.serviceAccounts.get(index);
  }
  public java.lang.String getFirstServiceAccount() {
    return this.serviceAccounts.get(0);
  }
  public java.lang.String getLastServiceAccount() {
    return this.serviceAccounts.get(serviceAccounts.size() - 1);
  }
  public java.lang.String getMatchingServiceAccount(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: serviceAccounts) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingServiceAccount(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: serviceAccounts) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withServiceAccounts(java.util.List<java.lang.String> serviceAccounts) {
    if (serviceAccounts != null) {this.serviceAccounts = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : serviceAccounts){this.addToServiceAccounts(item);}} else { this.serviceAccounts = null;} return (A) this;
  }
  public A withServiceAccounts(java.lang.String... serviceAccounts) {
    if (this.serviceAccounts != null) {this.serviceAccounts.clear();}
    if (serviceAccounts != null) {for (java.lang.String item :serviceAccounts){ this.addToServiceAccounts(item);}} return (A) this;
  }
  public java.lang.Boolean hasServiceAccounts() {
    return serviceAccounts != null && !serviceAccounts.isEmpty();
  }
  public A addNewServiceAccount(java.lang.String arg0) {
    return (A)addToServiceAccounts(new String(arg0));
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    OperatorConditionSpecFluentImpl that = (OperatorConditionSpecFluentImpl) o;
    if (deployments != null ? !deployments.equals(that.deployments) :that.deployments != null) return false;
    if (overrides != null ? !overrides.equals(that.overrides) :that.overrides != null) return false;
    if (serviceAccounts != null ? !serviceAccounts.equals(that.serviceAccounts) :that.serviceAccounts != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(deployments,  overrides,  serviceAccounts,  super.hashCode());
  }
  
}