package io.fabric8.openshift.api.model.operatorhub.v1;

import io.fabric8.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.fabric8.kubernetes.api.model.ObjectReferenceFluentImpl;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import io.fabric8.kubernetes.api.model.ObjectReference;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.model.ObjectReferenceBuilder;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

 /**
  * Generated
  */
public class OperatorGroupStatusFluentImpl<A extends io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent<A>{
  public OperatorGroupStatusFluentImpl() {
  }
  public OperatorGroupStatusFluentImpl(io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatus instance) {
    this.withLastUpdated(instance.getLastUpdated()); 
    this.withNamespaces(instance.getNamespaces()); 
    this.withServiceAccountRef(instance.getServiceAccountRef()); 
  }
  private java.lang.String lastUpdated;
  private java.util.List<java.lang.String> namespaces = new java.util.ArrayList<java.lang.String>();
  private io.fabric8.kubernetes.api.model.ObjectReferenceBuilder serviceAccountRef;
  public java.lang.String getLastUpdated() {
    return this.lastUpdated;
  }
  public A withLastUpdated(java.lang.String lastUpdated) {
    this.lastUpdated=lastUpdated; return (A) this;
  }
  public java.lang.Boolean hasLastUpdated() {
    return this.lastUpdated != null;
  }
  
  /**
   * Method is deprecated. use withLastUpdated instead.
   */
  @java.lang.Deprecated
  public A withNewLastUpdated(java.lang.String arg0) {
    return (A)withLastUpdated(new String(arg0));
  }
  public A addToNamespaces(java.lang.Integer index,java.lang.String item) {
    if (this.namespaces == null) {this.namespaces = new java.util.ArrayList<java.lang.String>();}
    this.namespaces.add(index, item);
    return (A)this;
  }
  public A setToNamespaces(java.lang.Integer index,java.lang.String item) {
    if (this.namespaces == null) {this.namespaces = new java.util.ArrayList<java.lang.String>();}
    this.namespaces.set(index, item); return (A)this;
  }
  public A addToNamespaces(java.lang.String... items) {
    if (this.namespaces == null) {this.namespaces = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.namespaces.add(item);} return (A)this;
  }
  public A addAllToNamespaces(java.util.Collection<java.lang.String> items) {
    if (this.namespaces == null) {this.namespaces = new java.util.ArrayList<java.lang.String>();}
    for (java.lang.String item : items) {this.namespaces.add(item);} return (A)this;
  }
  public A removeFromNamespaces(java.lang.String... items) {
    for (java.lang.String item : items) {if (this.namespaces!= null){ this.namespaces.remove(item);}} return (A)this;
  }
  public A removeAllFromNamespaces(java.util.Collection<java.lang.String> items) {
    for (java.lang.String item : items) {if (this.namespaces!= null){ this.namespaces.remove(item);}} return (A)this;
  }
  public java.util.List<java.lang.String> getNamespaces() {
    return this.namespaces;
  }
  public java.lang.String getNamespace(java.lang.Integer index) {
    return this.namespaces.get(index);
  }
  public java.lang.String getFirstNamespace() {
    return this.namespaces.get(0);
  }
  public java.lang.String getLastNamespace() {
    return this.namespaces.get(namespaces.size() - 1);
  }
  public java.lang.String getMatchingNamespace(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: namespaces) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingNamespace(java.util.function.Predicate<java.lang.String> predicate) {
    for (java.lang.String item: namespaces) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withNamespaces(java.util.List<java.lang.String> namespaces) {
    if (namespaces != null) {this.namespaces = new java.util.ArrayList<java.lang.String>(); for (java.lang.String item : namespaces){this.addToNamespaces(item);}} else { this.namespaces = null;} return (A) this;
  }
  public A withNamespaces(java.lang.String... namespaces) {
    if (this.namespaces != null) {this.namespaces.clear();}
    if (namespaces != null) {for (java.lang.String item :namespaces){ this.addToNamespaces(item);}} return (A) this;
  }
  public java.lang.Boolean hasNamespaces() {
    return namespaces != null && !namespaces.isEmpty();
  }
  public A addNewNamespace(java.lang.String arg0) {
    return (A)addToNamespaces(new String(arg0));
  }
  
  /**
   * This method has been deprecated, please use method buildServiceAccountRef instead.
   * @return The buildable object.
   */
  @java.lang.Deprecated
  public io.fabric8.kubernetes.api.model.ObjectReference getServiceAccountRef() {
    return this.serviceAccountRef!=null?this.serviceAccountRef.build():null;
  }
  public io.fabric8.kubernetes.api.model.ObjectReference buildServiceAccountRef() {
    return this.serviceAccountRef!=null?this.serviceAccountRef.build():null;
  }
  public A withServiceAccountRef(io.fabric8.kubernetes.api.model.ObjectReference serviceAccountRef) {
    _visitables.get("serviceAccountRef").remove(this.serviceAccountRef);
    if (serviceAccountRef!=null){ this.serviceAccountRef= new io.fabric8.kubernetes.api.model.ObjectReferenceBuilder(serviceAccountRef); _visitables.get("serviceAccountRef").add(this.serviceAccountRef);} return (A) this;
  }
  public java.lang.Boolean hasServiceAccountRef() {
    return this.serviceAccountRef != null;
  }
  public io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<A> withNewServiceAccountRef() {
    return new io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluentImpl.ServiceAccountRefNestedImpl();
  }
  public io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<A> withNewServiceAccountRefLike(io.fabric8.kubernetes.api.model.ObjectReference item) {
    return new io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluentImpl.ServiceAccountRefNestedImpl(item);
  }
  public io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<A> editServiceAccountRef() {
    return withNewServiceAccountRefLike(getServiceAccountRef());
  }
  public io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<A> editOrNewServiceAccountRef() {
    return withNewServiceAccountRefLike(getServiceAccountRef() != null ? getServiceAccountRef(): new io.fabric8.kubernetes.api.model.ObjectReferenceBuilder().build());
  }
  public io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<A> editOrNewServiceAccountRefLike(io.fabric8.kubernetes.api.model.ObjectReference item) {
    return withNewServiceAccountRefLike(getServiceAccountRef() != null ? getServiceAccountRef(): item);
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    OperatorGroupStatusFluentImpl that = (OperatorGroupStatusFluentImpl) o;
    if (lastUpdated != null ? !lastUpdated.equals(that.lastUpdated) :that.lastUpdated != null) return false;
    if (namespaces != null ? !namespaces.equals(that.namespaces) :that.namespaces != null) return false;
    if (serviceAccountRef != null ? !serviceAccountRef.equals(that.serviceAccountRef) :that.serviceAccountRef != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(lastUpdated,  namespaces,  serviceAccountRef,  super.hashCode());
  }
  public class ServiceAccountRefNestedImpl<N> extends io.fabric8.kubernetes.api.model.ObjectReferenceFluentImpl<io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<N>> implements io.fabric8.openshift.api.model.operatorhub.v1.OperatorGroupStatusFluent.ServiceAccountRefNested<N>,io.fabric8.kubernetes.api.builder.Nested<N>{
    ServiceAccountRefNestedImpl(io.fabric8.kubernetes.api.model.ObjectReference item) {
      this.builder = new io.fabric8.kubernetes.api.model.ObjectReferenceBuilder(this, item);
    }
    ServiceAccountRefNestedImpl() {
      this.builder = new io.fabric8.kubernetes.api.model.ObjectReferenceBuilder(this);
    }
    io.fabric8.kubernetes.api.model.ObjectReferenceBuilder builder;
    public N and() {
      return (N) OperatorGroupStatusFluentImpl.this.withServiceAccountRef(builder.build());
    }
    public N endServiceAccountRef() {
      return and();
    }
    
  }
  
}