package io.fabric8.openshift.api.model.operatorhub.v1alpha1;

import io.fabric8.kubernetes.api.model.rbac.PolicyRule;
import java.util.ArrayList;
import java.lang.String;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import io.fabric8.kubernetes.api.builder.BaseFluent;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;

 /**
  * Generated
  */
public class StrategyDeploymentPermissionsFluentImpl<A extends io.fabric8.openshift.api.model.operatorhub.v1alpha1.StrategyDeploymentPermissionsFluent<A>> extends io.fabric8.kubernetes.api.builder.BaseFluent<A> implements io.fabric8.openshift.api.model.operatorhub.v1alpha1.StrategyDeploymentPermissionsFluent<A>{
  public StrategyDeploymentPermissionsFluentImpl() {
  }
  public StrategyDeploymentPermissionsFluentImpl(io.fabric8.openshift.api.model.operatorhub.v1alpha1.StrategyDeploymentPermissions instance) {
    this.withRules(instance.getRules()); 
    this.withServiceAccountName(instance.getServiceAccountName()); 
  }
  private java.util.List<io.fabric8.kubernetes.api.model.rbac.PolicyRule> rules = new java.util.ArrayList<io.fabric8.kubernetes.api.model.rbac.PolicyRule>();
  private java.lang.String serviceAccountName;
  public A addToRules(java.lang.Integer index,io.fabric8.kubernetes.api.model.rbac.PolicyRule item) {
    if (this.rules == null) {this.rules = new java.util.ArrayList<io.fabric8.kubernetes.api.model.rbac.PolicyRule>();}
    this.rules.add(index, item);
    return (A)this;
  }
  public A setToRules(java.lang.Integer index,io.fabric8.kubernetes.api.model.rbac.PolicyRule item) {
    if (this.rules == null) {this.rules = new java.util.ArrayList<io.fabric8.kubernetes.api.model.rbac.PolicyRule>();}
    this.rules.set(index, item); return (A)this;
  }
  public A addToRules(io.fabric8.kubernetes.api.model.rbac.PolicyRule... items) {
    if (this.rules == null) {this.rules = new java.util.ArrayList<io.fabric8.kubernetes.api.model.rbac.PolicyRule>();}
    for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item : items) {this.rules.add(item);} return (A)this;
  }
  public A addAllToRules(java.util.Collection<io.fabric8.kubernetes.api.model.rbac.PolicyRule> items) {
    if (this.rules == null) {this.rules = new java.util.ArrayList<io.fabric8.kubernetes.api.model.rbac.PolicyRule>();}
    for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item : items) {this.rules.add(item);} return (A)this;
  }
  public A removeFromRules(io.fabric8.kubernetes.api.model.rbac.PolicyRule... items) {
    for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item : items) {if (this.rules!= null){ this.rules.remove(item);}} return (A)this;
  }
  public A removeAllFromRules(java.util.Collection<io.fabric8.kubernetes.api.model.rbac.PolicyRule> items) {
    for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item : items) {if (this.rules!= null){ this.rules.remove(item);}} return (A)this;
  }
  public java.util.List<io.fabric8.kubernetes.api.model.rbac.PolicyRule> getRules() {
    return this.rules;
  }
  public io.fabric8.kubernetes.api.model.rbac.PolicyRule getRule(java.lang.Integer index) {
    return this.rules.get(index);
  }
  public io.fabric8.kubernetes.api.model.rbac.PolicyRule getFirstRule() {
    return this.rules.get(0);
  }
  public io.fabric8.kubernetes.api.model.rbac.PolicyRule getLastRule() {
    return this.rules.get(rules.size() - 1);
  }
  public io.fabric8.kubernetes.api.model.rbac.PolicyRule getMatchingRule(java.util.function.Predicate<io.fabric8.kubernetes.api.model.rbac.PolicyRule> predicate) {
    for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item: rules) { if(predicate.test(item)){ return item;} } return null;
  }
  public java.lang.Boolean hasMatchingRule(java.util.function.Predicate<io.fabric8.kubernetes.api.model.rbac.PolicyRule> predicate) {
    for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item: rules) { if(predicate.test(item)){ return true;} } return false;
  }
  public A withRules(java.util.List<io.fabric8.kubernetes.api.model.rbac.PolicyRule> rules) {
    if (rules != null) {this.rules = new java.util.ArrayList<io.fabric8.kubernetes.api.model.rbac.PolicyRule>(); for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item : rules){this.addToRules(item);}} else { this.rules = null;} return (A) this;
  }
  public A withRules(io.fabric8.kubernetes.api.model.rbac.PolicyRule... rules) {
    if (this.rules != null) {this.rules.clear();}
    if (rules != null) {for (io.fabric8.kubernetes.api.model.rbac.PolicyRule item :rules){ this.addToRules(item);}} return (A) this;
  }
  public java.lang.Boolean hasRules() {
    return rules != null && !rules.isEmpty();
  }
  public java.lang.String getServiceAccountName() {
    return this.serviceAccountName;
  }
  public A withServiceAccountName(java.lang.String serviceAccountName) {
    this.serviceAccountName=serviceAccountName; return (A) this;
  }
  public java.lang.Boolean hasServiceAccountName() {
    return this.serviceAccountName != null;
  }
  
  /**
   * Method is deprecated. use withServiceAccountName instead.
   */
  @java.lang.Deprecated
  public A withNewServiceAccountName(java.lang.String arg0) {
    return (A)withServiceAccountName(new String(arg0));
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    StrategyDeploymentPermissionsFluentImpl that = (StrategyDeploymentPermissionsFluentImpl) o;
    if (rules != null ? !rules.equals(that.rules) :that.rules != null) return false;
    if (serviceAccountName != null ? !serviceAccountName.equals(that.serviceAccountName) :that.serviceAccountName != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(rules,  serviceAccountName,  super.hashCode());
  }
  
}